install 11 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. OSInfo() {
  11. #printf "Detectando SO..."
  12. debianOS=false
  13. rhelOS=false
  14. OS=$(uname -s)
  15. if [ $OS = "Linux" ]; then
  16. OS="GNU/Linux"
  17. if [ -f /etc/os-release ]; then
  18. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  19. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  20. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  21. for i in $ID_LIKE; do
  22. #printf "$i\n"
  23. case $i in
  24. debian|ubuntu)
  25. debianOS=true
  26. break
  27. ;;
  28. rhel|fedora)
  29. rhelOS=true
  30. break
  31. ;;
  32. *)
  33. debianOS=false
  34. rhelOS=false
  35. ;;
  36. esac
  37. done
  38. elif [ -f /etc/debian-version ]; then
  39. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  40. DIST="Debian"
  41. REV=""
  42. ID_LIKE="debian"
  43. debianOS=true
  44. elif [ -f /etc/redhat-release ]; then
  45. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  46. DIST="Red-Hat"
  47. REV=""
  48. ID_LIKE="rhel"
  49. rhelOS=true
  50. else
  51. # Other Linux (No Soportado)
  52. DIST=""
  53. REV=""
  54. ID_LIKE=""
  55. fi
  56. else
  57. # UNIX, OS X, ... (No Soportado)
  58. DIST=$OS
  59. REV=""
  60. fi
  61. #printf " $OS $DIST $REV\n"
  62. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  63. }
  64. comprobarRoot() {
  65. if [ $(id -u) -ne 0 ]; then
  66. printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
  67. exit 1
  68. fi
  69. }
  70. comprobarDependencias() {
  71. # Comprobamos whiptail
  72. which whiptail > /dev/null 2>&1
  73. if [ $? -ne 0 ];then
  74. printf "ERROR:\t'whiptail' no disponible.\n"
  75. exit 1
  76. fi
  77. # Comprobamos hostnamectl
  78. which hostnamectl > /dev/null 2>&1
  79. if [ $? -ne 0 ];then
  80. printf "ERROR:\t'hostnamectl' no disponible.\n"
  81. exit 1
  82. fi
  83. if [ $debianOS = true ];then
  84. # Comprobamos apt-get
  85. which apt-get > /dev/null 2>&1
  86. if [ $? -ne 0 ]; then
  87. printf "ERROR:\t'apt-get' no está disponible.\n"
  88. exit 1
  89. fi
  90. # Actualizamos base de datos del repositorio
  91. printf "Actualizando repositorio APT..."
  92. result=$(apt-get -q -y update)
  93. if [ $? -ne 0 ]; then
  94. printf "\nERROR:\tImposible actualizar repositorio.\n"
  95. printf "Detalles:\n$result\n"
  96. exit 1
  97. fi
  98. printf " OK.\n"
  99. # Comprobamos Firewall (ufw)
  100. which ufw > /dev/null 2>&1
  101. if [ $? -ne 0 ]; then
  102. printf "ERROR:\t'ufw' no disponible.\n"
  103. exit 1
  104. fi
  105. fi
  106. if [ $rhelOS = true ]; then
  107. # Comprobamos yum
  108. which yum > /dev/null 2>&1
  109. if [ $? -ne 0 ]; then
  110. printf "ERROR:\t'yum' no está disponible.\n"
  111. exit 1
  112. fi
  113. # Actualizamos base de datos del repositorio
  114. printf "Actualizando repositorio YUM..."
  115. result=$(yum -y makecache 2>&1)
  116. if [ $? -ne 0 ]; then
  117. printf "\nERROR:\tImposible actualizar repositorio.\n"
  118. printf "Detalles:\n$result\n"
  119. exit 1
  120. fi
  121. printf " OK.\n"
  122. # Comprobamos Firewall (firewall-cmd)
  123. which firewall-cmd > /dev/null 2>&1
  124. if [ $? -ne 0 ]; then
  125. printf "ERROR:\t'firewall-cmd' no disponible.\n"
  126. exit 1
  127. fi
  128. fi
  129. }
  130. comprobarHostname() {
  131. while [ -z $hostname ]; do
  132. hostname=$(whiptail --title "HOSTNAME" --inputbox "El nombre de dominio de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" --ok-button "Cambiar" --cancel-button "No Cambiar" 20 70 3>&1 1>&2 2>&3)
  133. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  134. hostnamectl set-hostname $hostname
  135. else
  136. hostname=$(hostname)
  137. fi
  138. done
  139. #printf "\nHostname: $hostname\n"
  140. }
  141. mostrarBienvenida() {
  142. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  143. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --ok-button "Salir" 20 70
  144. exit 1
  145. fi
  146. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --yes-button "Continuar" --no-button "Salir" 20 70
  147. if [ $? -ne 0 ]; then
  148. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  149. exit 2
  150. fi
  151. }
  152. mostrarComponentes() {
  153. componentes=$(whiptail --title "INSTALACION" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 7 \
  154. "WebServer" "Instalar servidor web http/https" ON \
  155. "Database" "Instalar una base de datos SQL" ON \
  156. "PHP" "Instala PHP7" ON \
  157. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  158. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  159. "Moodle" "Instalar campus virtual con Moodle" ON \
  160. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  161. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  162. if [ $? -ne 0 ]; then
  163. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  164. exit 2
  165. fi
  166. # Mejora: autodetección de componentes ya instalados
  167. for i in $componentes; do
  168. case $i in
  169. \"WebServer\")
  170. printf "Instalando Servidor Web"
  171. instalarWebServer
  172. printf " OK.\n"
  173. ;;
  174. \"Database\")
  175. printf "Instalando Servidor Database"
  176. instalarDatabase
  177. printf " OK.\n"
  178. ;;
  179. \"PHP\")
  180. printf "Instalando PHP..."
  181. printf " OK.\n"
  182. ;;
  183. \"SSL/TLS\")
  184. printf "Instalando SSL/TLS..."
  185. printf " OK.\n"
  186. ;;
  187. \"MediaWiki\")
  188. printf "Instalando MediaWiki..."
  189. printf " OK.\n"
  190. ;;
  191. \"Moodle\")
  192. printf "Instalando Moodle..."
  193. printf " OK.\n"
  194. ;;
  195. \"Actualizaciones\")
  196. printf "Configurando actualizaciones..."
  197. printf " OK.\n"
  198. ;;
  199. *)
  200. printf "ERROR:\tError interno (selección de componentes).\n"
  201. exit 1
  202. ;;
  203. esac
  204. done
  205. }
  206. instalarWebServer() {
  207. webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
  208. "Apache" "Instalar el servidor web Apache2" ON \
  209. "Nginx" "Instalar el servidor web Nginx" OFF \
  210. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  211. if [ $? -ne 0 ]; then
  212. printf "\nERROR:\tInstalación interrumpida por el usuario.\n"
  213. exit 2
  214. fi
  215. # Preguntar otras opciones de configuración
  216. comprobarHostname
  217. case $webServer in
  218. Apache)
  219. printf " Apache..."
  220. instalarApache
  221. ;;
  222. Nginx)
  223. printf " Nginx..."
  224. instalarNginx
  225. ;;
  226. *)
  227. printf "\nERROR:\tError interno (selección de web server).\n"
  228. exit 1
  229. ;;
  230. esac
  231. }
  232. instalarApache() {
  233. if [ $debianOS = true ];then
  234. result=$(apt-get -q -y install apache2 2>&1)
  235. if [ $? -ne 0 ]; then
  236. printf "\nERROR:\tError al instalar Apache2.\n"
  237. printf "Detalles:\n$result\n"
  238. exit 1
  239. fi
  240. elif [ $rhelOS = true ]; then
  241. result=$(yum -y install httpd 2>&1)
  242. if [ $? -ne 0 ]; then
  243. printf "\nERROR:\tError al instalar Apache2.\n"
  244. printf "Detalles:\n$result\n"
  245. exit 1
  246. fi
  247. else
  248. printf "\nERROR:\tError interno (instalación Apache2).\n"
  249. exit 1
  250. fi
  251. }
  252. instalarNginx() {
  253. if [ $debianOS = true ];then
  254. result=$(apt-get -q -y install nginx 2>&1)
  255. if [ $? -ne 0 ]; then
  256. printf "\nERROR:\tError al instalar Nginx.\n"
  257. printf "Detalles:\n$result\n"
  258. exit 1
  259. fi
  260. elif [ $rhelOS = true ]; then
  261. # Hay que instalar primero otro repositorio
  262. result=$(yum -y install epel-release)
  263. if [ $? -ne 0 ]; then
  264. printf "\nERROR:\tError al intalar repositorio 'epel-release'.\n"
  265. printf "Detalles:\n$result\n"
  266. exit 1
  267. fi
  268. result=$(yum -y install nginx 2>&1)
  269. if [ $? -ne 0 ]; then
  270. printf "\nERROR:\tError al instalar Nginx.\n"
  271. printf "Detalles:\n$result\n"
  272. exit 1
  273. fi
  274. else
  275. printf "\nERROR:\tError interno (instalación Nginx).\n"
  276. exit 1
  277. fi
  278. }
  279. instalarDatabase() {
  280. if [ $debianOS = true ]; then
  281. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
  282. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  283. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  284. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  285. if [ $? -ne 0 ]; then
  286. printf "\nERROR:\tInstalación interrumpida por el usuario.\n"
  287. exit 2
  288. fi
  289. # Preguntar otras opciones de configuración
  290. case $database in
  291. MySQL)
  292. printf " MySQL..."
  293. instalarMySQL
  294. ;;
  295. MariaDB)
  296. printf " MariaDB..."
  297. instalarMariaDB
  298. ;;
  299. *)
  300. printf "\nERROR:\tError interno (selección de base de datos).\n"
  301. exit 1
  302. ;;
  303. esac
  304. elif [ $rhelOS = true ]; then
  305. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." --yes-button "Continuar" --no-button "Salir" 20 70
  306. if [ $? -ne 0 ]; then
  307. printf "\nERROR:\tInstalación interrumpida por el usuario.\n"
  308. exit 2
  309. fi
  310. printf " MariaDB.."
  311. instalarMariaDB
  312. else
  313. printf "\nERROR:\tError interno (instalación Base de Datos).\n"
  314. exit 1
  315. fi
  316. }
  317. instalarMySQL() {
  318. if [ $debianOS = true ];then
  319. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  320. if [ $? -ne 0 ]; then
  321. printf "\nERROR:\tError al instalar MySQL.\n"
  322. printf "Detalles:\n$result\n"
  323. exit 1
  324. fi
  325. elif [ $rhelOS = true ]; then
  326. # MySQL no disponible en RHEL. 2 opciones:
  327. # 1) Instalar un repositorio adicional
  328. # 2) No instalar MySQL en distribuciones RHEL
  329. printf "\nERROR:\tRHEL no incluye MySQL en sus repositorios.\n"
  330. exit 1
  331. else
  332. printf "\nERROR:\tError interno (instalación MySQL).\n"
  333. exit 1
  334. fi
  335. }
  336. instalarMariaDB() {
  337. if [ $debianOS = true ];then
  338. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  339. if [ $? -ne 0 ]; then
  340. printf "\nERROR:\tError al instalar MariaDB.\n"
  341. printf "Detalles:\n$result\n"
  342. exit 1
  343. fi
  344. elif [ $rhelOS = true ]; then
  345. result=$(yum -y install mariadb-server 2>&1)
  346. if [ $? -ne 0 ]; then
  347. printf "\nERROR:\tError al instalar MariaDB.\n"
  348. printf "Detalles:\n$result\n"
  349. exit 1
  350. fi
  351. else
  352. printf "\nERROR:\tError interno (instalación MariaDB).\n"
  353. exit 1
  354. fi
  355. }
  356. # Comprobación del sistema
  357. comprobarRoot
  358. OSInfo
  359. comprobarDependencias
  360. # Bienvenida
  361. mostrarBienvenida
  362. # Mejora: instalación express vs instalación avanzada
  363. # Selección de componentes
  364. mostrarComponentes
  365. # Pre-configuración
  366. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  367. # Instalación
  368. # Cuando funcionen todos los instaladores, cambiarlo por variables de estado e instalar en este punto
  369. # whiptail --gauge
  370. # Configuración
  371. # Configuración Apache
  372. # Virtual Hosts
  373. # Configuración Database
  374. # Configuración Segura
  375. # Configuración PHP
  376. # cgi.fix_pathinfo=0
  377. # Configurar máximo de subida de archivos
  378. # Configuración MediWiki
  379. # Configuración Moodle
  380. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  381. # Añadir reglas del cortafuegos
  382. # Configuración SSL/TLS
  383. # Generar certificados
  384. # Configurar certificados
  385. # Configurar actualización
  386. # Autodestrucción
  387. {
  388. for i in $(seq 0 5 50); do
  389. sleep 0.1
  390. echo $i
  391. done
  392. } | whiptail --gauge "Autodestrucción..." 7 70 0
  393. {
  394. for i in $(seq 50 5 100); do
  395. sleep 0.1
  396. echo $i
  397. done
  398. } | whiptail --gauge "Autopulverización..." 7 70 50